// globals, character class,  collision fn
/* ---------------------		character class 		-------------------- */
function character() {
}
character.prototype = new MovieClip();
//character fns.
character.prototype.init = function(x, y) {
	this._x = x;
	this._y = y;
	this.dir = 1;
	this.status = "normal";
	this.action = "";
	//turn stuff
	this.unhurt = 0;
	this.nextturn = 0;
	this.maxHealth = 100;
	this.health = 100;
	this.speed = 1;
	this.strength = 5;
	this.dist = 0;
	this.itemdrop = "";
	this.kind = "friendly";
	this.class = "";
};
character.prototype.move = function() {
	var oldx = this._x;
	var oldy = this._y;
	switch (this.dir) {
	case 1 :
		this.gotoAndPlay("down");
		this._y += this.dist;
		break;
	case 2 :
		this.gotoAndPlay("right");
		this._x += this.dist;
		break;
	case 3 :
		this.gotoAndPlay("left");
		this._x -= this.dist;
		break;
	case 4 :
		this.gotoAndPlay("up");
		this._y -= this.dist;
		break;
	}
	if (this.collision()) {
		this._x = oldx;
		this._y = oldy;
	}
};
character.prototype.onEnterFrame = function() {
	if ((_glob.mode == 0) && (not _glob.message)) {
		if (this.health>=0) {
			if (this.nextturn<=_glob.turn) {
				this.taketurn();
				this.move();
				if (this.action<>"") {
					switch (this.action) {
					case "attack" :
						this.attack();
						break;
					case "talk" :
						this.talk();
						break;
					case "use" :
					var item = _glob.useItem;
						if (item <> "") {
							this.use(item);
						} else {
							dialogue("You don't have an item selected.");
						}
						break;
					}
				}
				this.nextturn = _glob.turn+this.speed;
			}
		} else {
			this.die();
		}
	}
};
character.prototype.taketurn = function() {
	this.dist = 0;
	this.action = "";
	if (this.status == "hurt") {
		setColor(this, 100, 80, 80, 75);
		if (this.unhurt<=_glob.turn) {
			this.status = "normal";
			setColor(this, 100, 100, 100, 100);
		}
	}
};
character.prototype.hit = function(enemy) {
	//trace(this + " hit by " + enemy + "; health at " + this.health + ".");
	//trace("enemy strength: " + enemy.strength);
	this.health -= enemy.strength;
	this.status = "hurt";
	this.unhurt = _glob.turn+15;
};
character.prototype.die = function() {
	if (this.itemdrop<>"") {
		createObj(this.itemdrop, this.itemdrop+_glob.objn, this._x, this._y);
		_glob.objn++;
		removeMovieClip(this);
	} else {
		this.gotoAndPlay("dead");
	}
};
character.prototype.collision = function() {
	var o = this.body.getBounds(scr);
	var walls = scr.walls;
	if ((walls.hitTest(o.xMax, o.yMax, true)) or (walls.hitTest(o.xMax, o.yMin+TILE, true)) or (walls.hitTest(o.xMin, o.yMax, true)) or (walls.hitTest(o.xMin, o.yMin+TILE, true))) {
		return (true);
	}
};
