// specific characters
// ----------------------------------------------------
function protagonist() {
}
protagonist.prototype = new character();
protagonist.prototype.init = function(x, y) {
	this._height = TILE*2;
	this._width = TILE;
	super.init(x, y);
	this.maxHealth = 4;
	this.health = 4;
	this.speed = 1;
	this.strength = 5;
	this.kind = "self";
};
protagonist.prototype.taketurn = function() {
	super.taketurn();
	if (Key.isDown(Key.DOWN)) {
		this.dir = 1;
		this.dist = 5;
	}
	if (Key.isDown(Key.RIGHT)) {
		this.dir = 2;
		this.dist = 5;
	}
	if (Key.isDown(Key.LEFT)) {
		this.dir = 3;
		this.dist = 5;
	}
	if (Key.isDown(Key.UP)) {
		this.dir = 4;
		this.dist = 5;
	}
	if (Key.isDown(KEYa)) {
		if (not this.hitTest(scr.talk_area)) {
			this.action = "attack";
		} else {
			this.action = "talk";
		}
	}
	if (Key.isDown(KEYd)) {
		this.action = "use";
	}
};
protagonist.prototype.move = function() {
	super.move();
	var newpos = [this._x, this._y];
	var curscreen = _glob.current_screen;
	var bounds = scr.getBounds(_root);
	var doorflag = false;
	if (this._x>bounds.xMax) {
		_glob.current_screen++;
		newpos[0] = 0;
	}
	if (this._x<bounds.xMin) {
		_glob.current_screen--;
		newpos[0] = bounds.xMax;
	}
	if (this._y>bounds.yMax) {
		_glob.current_screen += 10;
		newpos[1] = 0;
	}
	if (this._y<bounds.yMin) {
		_glob.current_screen -= 10;
		newpos[1] = bounds.yMax;
	}
	if (this.hitTest(scr.door)) {
		newpos = this.enterDoor();
		doorflag = true;
	}
	if ((curscreen<>_glob.current_screen) && (doorflag == false)) {
		load_screen(_glob.current_screen);
	}
	this._x = newpos[0];
	this._y = newpos[1];
};
protagonist.prototype.enterDoor = function() {
	var s, doorTo;
	var ret = [this._x, this._y];
	s = screen[_glob.current_screen];
	doorTo = screen[s.doorTo];
	_glob.current_screen = s.doorTo;
	load_screen(_glob.current_screen);
	ret[0] = scr.door._x;
	if (doorTo.enter == "up") {
		ret[1] = scr.door._y-TILE*2;
	}
	if (doorTo.enter == "down") {
		ret[1] = scr.door._y+TILE;
	}
	return (ret);
};
protagonist.prototype.collision = function() {
	var ret = super.collision();
	var ii = _glob.charList.length;
	for (var i = 0; i<ii; i++) {
		var oo = eval(_glob.charList[i]);
		if ((this.status<>"hurt") && (oo.kind == "hostile")) {
			if (oo.body.hitTest(this.body)) {
				this.hit(oo);
			}
		}
		if (oo.kind == "item") {
			if (oo.hitTest(this.body)) {
				oo.pickup();
			}
		}
		if (oo.kind == "friendly") {
			if (oo.hitTest(this.body)) {
				ret = true;
			}
		}
	}
	return (ret);
};
protagonist.prototype.talk = function() {
	var s = _glob.charList[1];
		eval(s).talk(0);
	
};
protagonist.prototype.use = function(item) {
	var c = getN(item);
	var n = inv.cards[c[1]];
	if (n == 0) {
		dialogue("You don't have any left.");
	} else {
		if (not this.hitTest(scr.talk_area)) {
			dialogue("You can't use that now.");
		} else {
			eval(_glob.charList[1]).talk(item);
		}
	}
};
protagonist.prototype.attack = function() {
	var o = this.getBounds(_root);
	var xhit, yhit;
	switch (this.dir) {
	case 1 :
		this.gotoAndPlay("attack_down");
		xhit = o.xMin+(TILE/2);
		yhit = o.yMax+TILE;
		break;
	case 2 :
		this.gotoAndPlay("attack_right");
		xhit = o.xMax+(TILE/2);
		yhit = o.yMin+TILE;
		break;
	case 3 :
		this.gotoAndPlay("attack_left");
		xhit = o.xMin-(TILE/2);
		yhit = o.yMin+TILE;
		break;
	case 4 :
		this.gotoAndPlay("attack_up");
		xhit = o.xMin+(TILE/2);
		yhit = o.yMin-TILE;
		break;
	default :
		trace("error");
	}
	var ii = _glob.charList.length;
	for (var i = 0; i<ii; i++) {
		var oo = eval(_glob.charList[i]);
		if ((oo<>this) && (oo.status<>"hurt") && (oo.hitTest(this.weapon))) {
			oo.hit(this);
		}
	}
};
protagonist.prototype.die = function() {
	GAMEOVER = 1;
	//gotoAndPlay("ending", 1);
};
Object.registerClass("char1", protagonist);
